package com.diagbot.repository;

import com.diagbot.entity.node.EntityInfo;
import com.diagbot.entity.node.LisCritical;
import org.springframework.data.neo4j.annotation.Query;
import org.springframework.data.neo4j.repository.Neo4jRepository;
import org.springframework.data.repository.query.Param;

import java.util.List;


public interface LisCriticalRepository extends Neo4jRepository<LisCritical, Long> {

    List<LisCritical> findByNameIs(String name);

    List<LisCritical> findByNameContaining(String name);

    List<LisCritical> findByNameIn(List<String> names);

    @Query("match (n:实验室检查危急值) \n" +
            "where id(n) = :#{#entityInfo.id} \n" +
            "set  " +
            "n.name = :#{#entityInfo.name}," +
            "n.拼音编码 = :#{#entityInfo.pycode}," +
            "n.静态知识标识 = :#{#entityInfo.is_kl}," +
            "n.状态 = :#{#entityInfo.status}," +
            "n.单位 = {unit}" +
            "\n" +
            "RETURN n,[ (n)-[r]->(m) | [ r, m ] ], ID(n)\n")
    LisCritical update(@Param("entityInfo") EntityInfo entityInfo,
                       @Param("unit") String unit);

    @Query("create (n:实验室检查危急值) \n" +
            "set  " +
            "n.name = :#{#entityInfo.name}," +
            "n.拼音编码 = :#{#entityInfo.pycode}," +
            "n.静态知识标识 = :#{#entityInfo.is_kl}," +
            "n.状态 = :#{#entityInfo.status}," +
            "n.单位 = {unit}" +
            "\n" +
            "RETURN n,[ (n)-[r]->(m) | [ r, m ] ], ID(n)\n")
    LisCritical create(@Param("entityInfo") EntityInfo entityInfo,
                       @Param("unit") String unit);

}