package com.diagbot.repository;

import com.diagbot.entity.node.EntityInfo;
import com.diagbot.entity.node.MedAllergen;
import org.springframework.data.neo4j.annotation.Query;
import org.springframework.data.neo4j.repository.Neo4jRepository;
import org.springframework.data.repository.query.Param;

import java.util.List;


public interface MedAllergenRepository extends Neo4jRepository<MedAllergen, Long> {

    List<MedAllergen> findByNameIs(String name);

    List<MedAllergen> findByNameIn(List<String> names);

    List<MedAllergen> findByNameContaining(String name);

    @Query("match (n:药物过敏原) \n" +
            "where id(n) = :#{#entityInfo.id} \n" +
            "set  " +
            "n.name = :#{#entityInfo.name}," +
            "n.拼音编码 = :#{#entityInfo.pycode}," +
            "n.静态知识标识 = :#{#entityInfo.is_kl}," +
            "n.状态 = :#{#entityInfo.status}," +
            "n.药品类型 = {medtype}," +
            "n.结果 = {result}," +
            "n.名称 = {alias}" +
            "\n" +
            "RETURN n,[ (n)-[r]->(m) | [ r, m ] ], ID(n)\n")
    MedAllergen update(@Param("entityInfo") EntityInfo entityInfo,
                       @Param("medtype") String medtype,
                       @Param("result") String result,
                       @Param("alias") String alias);

    @Query("create (n:药物过敏原) \n" +
            "set  " +
            "n.name = :#{#entityInfo.name}," +
            "n.拼音编码 = :#{#entityInfo.pycode}," +
            "n.静态知识标识 = :#{#entityInfo.is_kl}," +
            "n.状态 = :#{#entityInfo.status}," +
            "n.药品类型 = {medtype}," +
            "n.结果 = {result}," +
            "n.名称 = {alias}" +
            "\n" +
            "RETURN n,[ (n)-[r]->(m) | [ r, m ] ], ID(n)\n")
    MedAllergen create(@Param("entityInfo") EntityInfo entityInfo,
                       @Param("medtype") String medtype,
                       @Param("result") String result,
                       @Param("alias") String alias);
}

